<template>
  <v-card class="elevation-12">
      <Loading :visible="isLoading" />
      <v-form>
        <v-card class="elevation-12">
          <v-card-title>Entrez votre nouveau mot de passe </v-card-title>
          <v-card-text>
            <v-text-field  
              v-model="password" 
              label="Mot de passe"
              placeholder="Mot de passe"
              type="password"
              id="password"
              autocomplete="new-password"
              :error-messages="passErrors"
            />
          </v-card-text>
          <v-card-text>
            <v-text-field  
              v-model="confirmPass"
              label="Confirmation de mot de passe"
              placeholder="Confirmation de mot de passe"
              type="password"
              id="confirmPassword"
              :error-messages="confirmPassErrors"
            />
          </v-card-text>
          <v-card-actions>
            <v-btn color="secondary" light type="submit" @click="sendPassword">
              Sauvegarder
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-form>
  </v-card>
</template>


<script>
import {
  validationMixin
} from 'vuelidate';
import { mapActions } from 'vuex';
import {
  mapFields
} from 'vuex-map-fields';
import {
  required,
  sameAs,
  minLength
} from 'vuelidate/lib/validators';
import NotificationMixin from '../../mixins/NotificationMixin';
import Loading from '../../components/Loading';

export default {
  name: 'NewPasswordForm',
  mixins: [validationMixin, NotificationMixin],
  components:{
    Loading
  },
  validations: {
    password: {required, minLength: minLength(6)},
    confirmPass: {required, sameAsPassword: sameAs('password')}
  },
  data: () => ({
    password:'',
    confirmPass: '',
    token: '',
    errors: []
  }),
  computed: {
    passErrors () {
			const errors = []
			if (!this.$v.password.$dirty) return errors
			!this.$v.password.minLength && errors.push('Mot de passe trop court')
			!this.$v.password.required && errors.push('Mot de passe requis')
			return errors
		},
		confirmPassErrors () {
			const errors = []
			if (!this.$v.confirmPass.$dirty) return errors
			!this.$v.confirmPass.sameAsPassword && errors.push('Les mots de passes ne correspondent pas')
			!this.$v.confirmPass.required && errors.push('Confirmation de mot de passe requise')
			return errors
		},
    ...mapFields('user', ['passwordChanged','error', 'isLoading']),
  },
  created() {
    this.resetPasswordChanged();
    if (this.$route.params.token) {
      this.token = this.$route.params.token;
    }
  },
  methods: {
    sendPassword: function() {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      this.updatePassword({
        token: this.token,
        newPass : this.password
      });
      
    },
    ...mapActions('user', ['updatePassword', 'resetPasswordChanged'])
  },
  watch: {
    passwordChanged(newData) {
      if (newData) {
        this.$router.push({name:'login'});
        this.showMessage('Mot de passe modifié! Vous pouvez vous connecter' , 'success');   
      }
    },
    error(newError) {
      if(newError && newError['404'] && newError['404'] === 'There is no user with this token') {
        this.$router.push({name:'login'});
        this.showMessage('Le lien n\'est plus valable, veuillez réessayer' , 'error');   
      } else {
        this.showMessage('Une erreur s\'est produite, veuillez réessayer' , 'error');   
      }
    }
  }
}
</script>
